<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// object definition
	protected $obj_cpd;
	// variable definition
	protected $arr_search;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		/* -- Other object loaded below */
		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);
		$loaded_query = array('kegiatan');
		$this->obj_cpd->SetUsesQuery($loaded_query);
		// loaded javascript
		$this->obj_ctrl->LoadJavascript('jquery1.2.6', 'jquery');
		$this->obj_ctrl->LoadJavascript('autocomplete', 'jquery');
		$this->obj_ctrl->LoadJavascript('bgiframe', 'jquery');
		$this->obj_ctrl->LoadJavascript('ajaxqueue', 'jquery');
		// loaded style
		$this->obj_ctrl->LoadStyle('autocomplete', 'jquery');
		
	}
	
	public function PageView(){
		// Variable
		self::DisplayVariable();
		// Search Data
		self::GetSearchSession();
		// display List Kegiatan
		self::DisplayListKegiatan();
		// info iuran
		self::CheckPembayaranIuran();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	private function DisplayVariable(){
		// variable
		$this->obj_tmpl->addVar('content', 'URL_DASHBOARD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], 'dashboard', 'pribadi', 'p2kb'));
		$this->obj_tmpl->addVar('content', 'URL_LOG', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], 'buku', 'log'));
		$this->obj_tmpl->addVar('content', 'URL_BORANG', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'isian'));
		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));
		$this->obj_tmpl->addVar('content', 'URL_REMOTEDATA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'ajax-keyword'));
	}
	
	private function CheckPembayaranIuran(){
		$thn = date('Y');
		$bln_now = date('n');
		if($bln_now <= 6){
			$smt = 'II';	
			$thn = $thn - 1;
			$this->obj_tmpl->addVar('info_iuran', 'SEMESTER', $smt . ' (Juli s/d Desember)');
		}else{
			$smt = 'I';
			$this->obj_tmpl->addVar('info_iuran', 'SEMESTER', $smt . ' (Januari s/d Juni)');
		}
		$lunas = $this->obj_cpd->GetDataAsSingleArray("GetStatusPembayaranIuranByParams", array($thn, $smt, $this->str_userid));
		if(!isset($lunas['status_pelunasan']) OR $lunas['status_pelunasan'] == 'no'){
			$this->obj_tmpl->setAttribute('info_iuran', 'visibility', 'show');
		}
		// display tahun	
		$this->obj_tmpl->addVar('info_iuran', 'TAHUN', $thn);
	}
	
	private function GetSearchSession(){
		// search value
		$this->arr_search['keyword'] = "%";
		$this->arr_search['ranah'] = "";
		$this->arr_search['jenis'] = "";
		// ---
		if(isset($_SESSION['search']['borang'])){
			// keyword
			if(isset($_SESSION['search']['borang']['keyword']) AND !empty($_SESSION['search']['borang']['keyword'])){
				$this->obj_tmpl->addVar('content', 'KEYWORD', $_SESSION['search']['borang']['keyword']);
				$this->arr_search['keyword'] .= $_SESSION['search']['borang']['keyword'];	
			}
			// ranah 
			if(isset($_SESSION['search']['borang']['ranah']) AND !empty($_SESSION['search']['borang']['ranah'])){
				switch($_SESSION['search']['borang']['ranah']){
					case 1:					
						$this->obj_tmpl->addVar('content', 'RANAH_A', 'selected="selected"');
						break;
					case 2:
						$this->obj_tmpl->addVar('content', 'RANAH_B', 'selected="selected"');
						break;
					case 3:
						$this->obj_tmpl->addVar('content', 'RANAH_C', 'selected="selected"');
						break;
					case 4:
						$this->obj_tmpl->addVar('content', 'RANAH_D', 'selected="selected"');
						break;
					case 5:
						$this->obj_tmpl->addVar('content', 'RANAH_E', 'selected="selected"');
						break;
					default:
						break;
				}
				// parse
				$this->arr_search['ranah'] = "AND a.id_ranah = " . $_SESSION['search']['borang']['ranah']; 
			}
			// jenis 
			if(isset($_SESSION['search']['borang']['jenis']) AND !empty($_SESSION['search']['borang']['jenis'])){
				switch($_SESSION['search']['borang']['jenis']){
					case 1:					
						$this->obj_tmpl->addVar('content', 'PRIBADI', 'checked="checked"');
						break;
					case 2:
						$this->obj_tmpl->addVar('content', 'INTERNAL', 'checked="checked"');
						break;
					case 3:
						$this->obj_tmpl->addVar('content', 'EKSTERNAL', 'checked="checked"');
						break;
					default:
						break;
				}
				// parse
				$this->arr_search['jenis'] = "AND a.id_jenis = " . $_SESSION['search']['borang']['jenis']; 
			}
		}	
		// search value
		$this->arr_search['keyword'] .= "%";	
	}
	
	private function DisplayListKegiatan(){
		// parameter
		$params = array($this->arr_search['keyword'], $this->arr_search['ranah'], $this->arr_search['jenis']);
		// get data
		$rs_id = $this->obj_cpd->GetResourceId("GetListKegiatanBySearch", $params);
		// parse data
		$no = 1;
		if($rs_id){
			while($rec = mysql_fetch_assoc($rs_id)){
				// url
				$url = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'input', array($rec['id_kegiatan']));
				// parse
				$this->obj_tmpl->addVar('list_kegiatan', 'NO', $no . '.');
				$this->obj_tmpl->addVar('list_kegiatan', 'NAMA', $rec['kegiatan']);
				$this->obj_tmpl->addVar('list_kegiatan', 'RANAH', $rec['ranah']);
				$this->obj_tmpl->addVar('list_kegiatan', 'NAMA_RANAH', $rec['nama_ranah']);
				$this->obj_tmpl->addVar('list_kegiatan', 'JENIS', ucwords($rec['kelompok']));
				$this->obj_tmpl->addVar('list_kegiatan', 'KEGIATAN', $rec['kegiatan']);
				$this->obj_tmpl->addVar('list_kegiatan', 'URL_INPUT', $url);
				$this->obj_tmpl->ParseTemplate('list_kegiatan', 'a');
				$no++;
			}
		}
	}
	
}

?>