<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// object definition
	protected $obj_cpd;
	protected $obj_cpd_engine;
	protected $obj_notify;
	protected $obj_date;
	// variable
	protected $int_id_kegiatan;
	protected $int_id_form;
	protected $arr_field;
	protected $str_xml;
	protected $arr_detail;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		/* -- Other object loaded below */
		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);
		$loaded_query = array('kegiatan');
		$this->obj_cpd->SetUsesQuery($loaded_query);
		// --
		$this->obj_cpd_engine = $this->obj_ctrl->LoadBusiness('cpd_cpanel', 'mysql', $this->arr_config['db']);	
		// library loaded
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');	
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');
		// javascript loaded
		$this->obj_ctrl->LoadJavascript('dhtmlgoodies_calendar');
		// dhtmlgoodies_calendar loaded
		$this->obj_ctrl->LoadStyle('dhtmlgoodies_calendar', 'dhtmlgoodies_calendar');
		// dhtmlgoodies_calendar loaded body event
		$this->obj_ctrl->LoadEventOnBody("onload", "SetDhtmlgoodiesPathImages('".HTTPPATH."application/themes/dhtmlgoodies_calendar/img/');");
	}
	
	public function PageView(){
		// display variable
		self::DisplayVariable();
		// Display Detail Periode
		self::DisplayDetailPeriode();
		// Display Detail Kegiatan
		self::DisplayDetailKegiatan();
		// get xml data
		self::GetXmlData();
		// display test cookies
		self::DisplayNotification();
		// Display Elemen Kegiatan
		self::DisplayListElemen();
		// Display keterangan nilai
		self::DisplayListNilai();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	private function DisplayNotification(){
		// get session for start notification
		$this->obj_notify->GetMessage();
		// display message	
		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');
		// last field
		// field
		if(isset($this->obj_notify->arr_message['field'])){
			$strxml = $this->obj_notify->arr_message['field']['LAST_INPUT'];			
			$xml = simplexml_load_string($strxml);
			// echo does the casting for you
			$count = count($xml->item);
			for($i=0;$i<$count;$i++){
				$id = intval($xml->item[$i]->idt);
				$value = strval($xml->item[$i]->value);
				$this->arr_field[$id] = $value;
			}
		}	
		// clear session when finish
		$this->obj_notify->ClearSession();
	}
	
	private function DisplayVariable(){
		// variable
		$this->obj_tmpl->addVar('content', 'URL_STR', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'periode'));
		$this->obj_tmpl->addVar('content', 'URL_LIST', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'log'));
		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));
		// tahun periode str
		$this->obj_tmpl->addVar('content', 'URL_PERIODE', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'log', array($this->arr_routes['params'][0])));
		$this->obj_tmpl->addVar('content', 'URL_TAHUN', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'log', array($this->arr_routes['params'][0], $this->arr_routes['params'][1])));
		$this->obj_tmpl->addVar('content', 'URL_KEGIATAN', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'list', array($this->arr_routes['params'][0], $this->arr_routes['params'][1], $this->arr_routes['params'][2])));
	}
	
	private function DisplayDetailPeriode(){
		$params = array($this->str_userid, $this->arr_routes['params'][0]);
		$rs = $this->obj_cpd->GetDataAsSingleArray("GetDetailPeriodeStrByPerson", $params);
		$this->obj_tmpl->addVar('content', 'TAHUN_STR', $rs['tahun_awal'].' - '.$rs['tahun_akhir']);
	}
	
	private function DisplayDetailKegiatan(){
		// kegiatan
		$params = array($this->arr_routes['params'][3], $this->str_userid);
		$this->arr_detail = $this->obj_cpd->GetDataAsSingleArray("GetDetailKegiatanByIdLog", $params);
		// id form
		$this->int_id_form = $this->arr_detail['id_form'];
		// str xml
		$this->str_xml = $this->arr_detail['data_kegiatan'];
		// parse
		$this->obj_tmpl->addVar('content', 'ID_PERIODE', $this->arr_routes['params'][0]);
		$this->obj_tmpl->addVar('content', 'ID_TAHUN', $this->arr_routes['params'][1]);
		$this->obj_tmpl->addVar('content', 'ID_LOG', $this->arr_detail['id_log']);
		$this->obj_tmpl->addVar('content', 'ID_FORM', $this->arr_detail['id_form']);
		$this->obj_tmpl->addVar('content', 'IS_MANUAL', $this->arr_detail['is_manual']);
		$this->obj_tmpl->addVar('content', 'ID_KEGIATAN', $this->arr_detail['id_kegiatan']);
		$this->obj_tmpl->addVar('content', 'NAMA_KEGIATAN', $this->arr_detail['nama']);
	}
	
	private function GetXmlData(){
		// field
		if(isset($this->str_xml)){
			$strxml = $this->str_xml;			
			$xml = simplexml_load_string($strxml);
			// echo does the casting for you
			$count = count($xml->item);
			for($i=0;$i<$count;$i++){
				$id = intval($xml->item[$i]->idt);
				$value = strval($xml->item[$i]->value);
				$this->arr_field[$id] = $value;
			}
		}	
	}
	
	private function DisplayListElemen(){	
		// get detail form
		$params = array($this->int_id_form);
		$result = $this->obj_cpd->GetDataAsSingleArray("GetDetailFormById", $params);
		$this->obj_tmpl->addVar('content', 'DATE_LABEL', $result['date_label']);
		$this->obj_tmpl->addVar('content', 'DATE_LABEL_EN', $result['date_label_en']);
		// --			
		$params = array($this->int_id_form);
		$rs_id = $this->obj_cpd->GetResourceId("GetDisplayedElemenByIdForm", $params);
		if($rs_id){
			while($rs = mysql_fetch_assoc($rs_id)){
				$this->obj_tmpl->addVar('list_elemen', 'ID', $rs['id_elemen']);
				$this->obj_tmpl->addVar('list_elemen', 'LABEL', $rs['label']);
				$this->obj_tmpl->addVar('list_elemen', 'LABEL_EN', $rs['label_en']);		
				$this->obj_tmpl->addVar('list_elemen', 'VIEW', self::GetElemenView($rs));
				$this->obj_tmpl->ParseTemplate('list_elemen', 'a');
			}
		}
		// display skp manual
		if($this->arr_detail['is_manual'] == 'yes'){
			$this->obj_tmpl->addVar('skp_manual', 'display', 'manual');
		}
		$this->obj_tmpl->addVar('skp_manual', 'NILAI_SKP', $this->arr_detail['nilai_skp']);
		// nilai last input
		if(isset($this->obj_notify->arr_message['field']['NILAI'])){
			$this->obj_tmpl->addVar('skp_manual', 'NILAI_SKP', $this->obj_notify->arr_message['field']['NILAI']);
		}
		// display activities date
		if(isset($this->obj_notify->arr_message['field'])){
			$t = $this->obj_notify->arr_message['field']['TAHUN'];
			$b = $this->obj_notify->arr_message['field']['BULAN'];
			$h = $this->obj_notify->arr_message['field']['DAY'];
		}else{
			$tgl = explode('-', $this->arr_detail['tanggal_kegiatan']);
			$t = $tgl[0];
			$b = $tgl[1];
			$h = $tgl[2];
		}
		$this->obj_date->SetPatTemplates($this->obj_tmpl);
		$this->obj_date->DhtmlgoodiesStandardDate('list_year', 'list_month', 'list_day', $t, $b, $h, date('Y') - 10, date('Y'));
	}
	
	private function GetElemenView($rs){
		if(!isset($this->arr_field[$rs['id_elemen']])){ $this->arr_field[$rs['id_elemen']] = "";}
		$str_view = "";
		$value = explode(' ', $rs['label'], 2);
		$value = strtoupper($value[0]);
		switch($rs['tipe']){
			case 'text':
				$str_view ='<input type="text" size="'.$rs['elemen_size'].'" maxlength="'.$rs['elemen_maxlength'].'" name="data['.$rs['id_elemen'].']" value="'.$this->arr_field[$rs['id_elemen']].'" />';
				break;
			case 'textarea':
				$str_view ='<textarea rows="'.$rs['elemen_size'].'" cols="'.$rs['elemen_maxlength'].'" name="data['.$rs['id_elemen'].']">'.$this->arr_field[$rs['id_elemen']].'</textarea>';
				break;
			case 'filebrowse':
				// url
				$url = "#";
				$str_view = '<input type="file" name="data_'.$rs['id_elemen'].'" size="'.$rs['elemen_size'].'">';
				// check if last file exists
				$arr_data = $this->obj_cpd->GetDataAsSingleArray("GetDetailedDokumenBukti", array($this->str_userid, $this->arr_field[$rs['id_elemen']]));				
				if(!empty($arr_data)){
					$str_view .= '<input type="hidden" name="fd[data_'.$rs['id_elemen'].']" value="'.$this->arr_field[$rs['id_elemen']].'" >';
					$file = $arr_data['file_path'] . $arr_data['file_name'];
					if(!is_file($file)){
						$str_view .= '<a href="#">File Not Found</a>';
					}else{
						$url = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], 'dokumen', 'download', array(sha1(md5($this->str_userid)), md5(sha1($this->arr_field[$rs['id_elemen']]))));
						$str_view .= '<a href="'.$url.'">'.$arr_data['file_name'].'</a>';
					}	
				}else{
					$str_view .= '<a href="#">File Not Found</a>';
				}	
				break;
			case 'radio':
				$rs_id = $this->obj_cpd->GetResourceId("GetElemenListByIdElemen", array($rs['id_elemen']));
				if($rs_id){
					while($rec = mysql_fetch_assoc($rs_id)){
						if($this->arr_field[$rs['id_elemen']] == $rec['list_value'])
							$selected = 'checked="checked"';
						else
							$selected = '';
						$str_view .= '<label><input type="radio" name="data['.$rs['id_elemen'].']" value="'.$rec['list_value'].'" '.$selected.'>'.$rec['list_name'].'</label>';
					}
				}
				break;
			case 'selectbox':
				$str_view = '<select name="data['.$rs['id_elemen'].']">';
				$rs_id = $this->obj_cpd->GetResourceId("GetElemenListByIdElemen", array($rs['id_elemen']));
				if($rs_id){
					while($rec = mysql_fetch_assoc($rs_id)){
						if($this->arr_field[$rs['id_elemen']] == $rec['list_value'])
							$selected = 'selected="selected"';
						else
							$selected = '';
						$str_view .= '<option value="'.$rec['list_value'].'" '.$selected.'>'.$rec['list_name'].'</option>';
					}
				}
				$str_view .= '</select>';
				break;
			case 'date':				
				$str_view = self::CreateElemenDate($rs['id_elemen'], false);
				break;
			case 'datetime':				
				$str_view = self::CreateElemenDate($rs['id_elemen'], true);
				break;
			case 'spt_cabang':
				// loaded javascript
				$this->obj_ctrl->LoadJavascript('jquery1.2.6', 'jquery');
				$this->obj_ctrl->LoadJavascript('autocomplete', 'jquery');
				$this->obj_ctrl->LoadJavascript('bgiframe', 'jquery');
				$this->obj_ctrl->LoadJavascript('ajaxqueue', 'jquery');
				// loaded style
				$this->obj_ctrl->LoadStyle('autocomplete', 'jquery');
				// load javascript template
				$this->obj_tmpl->setAttribute('autocomplete', 'visibility', 'show');
				// parse input
				$this->obj_tmpl->addVar('list_autocomplete', 'ID', $rs['id_elemen']);
				$this->obj_tmpl->addVar('list_autocomplete', 'URL_REMOTEDATA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], 'borang', 'spt-cabang'));
				$str_view = '<input type="text" size="'.$rs['elemen_size'].'" maxlength="'.$rs['elemen_maxlength'].'" id="autocomplete_input_'.$rs['id_elemen'].'" name="data['.$rs['id_elemen'].']" value="'.$this->arr_field[$rs['id_elemen']].'" />';
				// append
				$this->obj_tmpl->ParseTemplate('list_autocomplete', 'a');		
				break;	
			case 'spt_klinik':
				// loaded javascript
				$this->obj_ctrl->LoadJavascript('jquery1.2.6', 'jquery');
				$this->obj_ctrl->LoadJavascript('autocomplete', 'jquery');
				$this->obj_ctrl->LoadJavascript('bgiframe', 'jquery');
				$this->obj_ctrl->LoadJavascript('ajaxqueue', 'jquery');
				// loaded style
				$this->obj_ctrl->LoadStyle('autocomplete', 'jquery');
				// load javascript template
				$this->obj_tmpl->setAttribute('autocomplete', 'visibility', 'show');
				// parse input
				$this->obj_tmpl->addVar('list_autocomplete', 'ID', $rs['id_elemen']);
				$this->obj_tmpl->addVar('list_autocomplete', 'URL_REMOTEDATA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], 'borang', 'spt-klinik'));
				$str_view = '<input type="text" size="'.$rs['elemen_size'].'" maxlength="'.$rs['elemen_maxlength'].'" id="autocomplete_input_'.$rs['id_elemen'].'" name="data['.$rs['id_elemen'].']" value="'.$this->arr_field[$rs['id_elemen']].'" />';
				// append
				$this->obj_tmpl->ParseTemplate('list_autocomplete', 'a');
				break;	
			case 'spt_rumkit':
				// loaded javascript
				$this->obj_ctrl->LoadJavascript('jquery1.2.6', 'jquery');
				$this->obj_ctrl->LoadJavascript('autocomplete', 'jquery');
				$this->obj_ctrl->LoadJavascript('bgiframe', 'jquery');
				$this->obj_ctrl->LoadJavascript('ajaxqueue', 'jquery');
				// loaded style
				$this->obj_ctrl->LoadStyle('autocomplete', 'jquery');
				// load javascript template
				$this->obj_tmpl->setAttribute('autocomplete', 'visibility', 'show');
				// parse input
				$this->obj_tmpl->addVar('list_autocomplete', 'ID', $rs['id_elemen']);
				$this->obj_tmpl->addVar('list_autocomplete', 'URL_REMOTEDATA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], 'borang', 'spt-hospital'));
				$str_view = '<input type="text" size="'.$rs['elemen_size'].'" maxlength="'.$rs['elemen_maxlength'].'" id="autocomplete_input_'.$rs['id_elemen'].'" name="data['.$rs['id_elemen'].']" value="'.$this->arr_field[$rs['id_elemen']].'" />';
				// append
				$this->obj_tmpl->ParseTemplate('list_autocomplete', 'a');
				break;	
			case 'spt_studi':
				// loaded javascript
				$this->obj_ctrl->LoadJavascript('jquery1.2.6', 'jquery');
				$this->obj_ctrl->LoadJavascript('autocomplete', 'jquery');
				$this->obj_ctrl->LoadJavascript('bgiframe', 'jquery');
				$this->obj_ctrl->LoadJavascript('ajaxqueue', 'jquery');
				// loaded style
				$this->obj_ctrl->LoadStyle('autocomplete', 'jquery');
				// load javascript template
				$this->obj_tmpl->setAttribute('autocomplete', 'visibility', 'show');
				// parse input
				$this->obj_tmpl->addVar('list_autocomplete', 'ID', $rs['id_elemen']);
				$this->obj_tmpl->addVar('list_autocomplete', 'URL_REMOTEDATA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], 'borang', 'spt-studi'));
				$str_view = '<input type="text" size="'.$rs['elemen_size'].'" maxlength="'.$rs['elemen_maxlength'].'" id="autocomplete_input_'.$rs['id_elemen'].'" name="data['.$rs['id_elemen'].']" value="'.$this->arr_field[$rs['id_elemen']].'" />';
				// append
				$this->obj_tmpl->ParseTemplate('list_autocomplete', 'a');
				break;	
			case 'spt_wilayah':
				// loaded javascript
				$this->obj_ctrl->LoadJavascript('jquery1.2.6', 'jquery');
				$this->obj_ctrl->LoadJavascript('autocomplete', 'jquery');
				$this->obj_ctrl->LoadJavascript('bgiframe', 'jquery');
				$this->obj_ctrl->LoadJavascript('ajaxqueue', 'jquery');
				// loaded style
				$this->obj_ctrl->LoadStyle('autocomplete', 'jquery');
				// load javascript template
				$this->obj_tmpl->setAttribute('autocomplete', 'visibility', 'show');
				// parse input
				$this->obj_tmpl->addVar('list_autocomplete', 'ID', $rs['id_elemen']);
				$this->obj_tmpl->addVar('list_autocomplete', 'URL_REMOTEDATA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], 'borang', 'spt-wilayah'));
				$str_view = '<input type="text" size="'.$rs['elemen_size'].'" maxlength="'.$rs['elemen_maxlength'].'" id="autocomplete_input_'.$rs['id_elemen'].'" name="data['.$rs['id_elemen'].']" value="'.$this->arr_field[$rs['id_elemen']].'" />';
				// append
				$this->obj_tmpl->ParseTemplate('list_autocomplete', 'a');
				break;
			default:
				$str_view = "";
				break;
		}
		return $str_view;
	}
	
	private function CreateElemenDate($id, $time = false){
		// filled
		if(isset($this->arr_field[$id])){
			$tgl = explode(' ', $this->arr_field[$id]);
			$tgl_filled = explode('-', $tgl[0]);
		}else{
			$tgl_filled = array(date('Y'), '01', '01');
		}
		// button
		$button = '<input type="button" value="kalender" onclick="displayCalendarSelectBox(form_input.tahun_'.$id.',form_input.bulan_'.$id.',form_input.day_'.$id.',false,false,this)">'; 
		// tahun 
		$tahun = '<select name="tahun_'.$id.'">';
		for($i=date('Y')-10;$i<=date('Y');$i++){
			if($tgl_filled[0] == $i)
				$selected = 'selected="selected"';
			else
				$selected = '';
			$tahun .= "<option value=\"$i\" $selected>$i</option>";
		}
		$tahun .= '</select>';
		// bulan
		$arr_bln = array('01' => 'Jan', '02' => 'Feb', '03' => 'Mar', '04' => 'Apr', '05' => 'May', '06' => 'Jun', '07' => 'Jul', '08' => 'Ags', '09' => 'Sep', '10' => 'Oct', '11' => 'Nov', '12' => 'Dec');
		$bulan = '<select name="bulan_'.$id.'">';
		foreach($arr_bln as $key => $val){
			if($tgl_filled[1] == $key)
				$selected = 'selected="selected"';
			else
				$selected = '';
			$bulan .= "<option value=\"$key\" $selected>$val</option>";
		}
		$bulan .= '</select>';
		// day
		$day = '<select name="day_'.$id.'">';
		for($i=1;$i<=31;$i++){
			if($tgl_filled[2] == $i)
				$selected = 'selected="selected"';
			else
				$selected = '';
			if($i<10)
					$i = '0' . $i;
			$day .= "<option value=\"$i\" $selected>$i</option>";
		}
		$day .= '</select>';
		//---------------------
		$hour = "";
		$minute = "";
		if($time){
			if(isset($tgl[1]))
				$time_filled = explode(':', $tgl[1]);
			else
				$time_filled = array('00', '00', '00');
			// hour
			$hour = '<select name="hour_'.$id.'">';
			for($i=1;$i<=23;$i++){
				if($time_filled[0] == $i)
					$selected = 'selected="selected"';
				else
					$selected = '';
				if($i<10)
					$i = '0' . $i;
				$hour .= "<option value=\"$i\" $selected>$i</option>";
			}
			$hour .= '</select>';
			// minute
			$minute = '<select name="minute_'.$id.'">';
			$i = 0;
			while($i<=55){
				if($time_filled[1] == $i)
					$selected = 'selected="selected"';
				else
					$selected = '';
				if($i<10)
					$i = '0' . $i;
				$minute .= "<option value=\"$i\" $selected>$i</option>";
				$i = $i + 5;
			}
			$minute .= '</select>';
			// button
			$button = '<input type="button" value="kalender" onclick="displayCalendarSelectBox(form_input.tahun_'.$id.',form_input.bulan_'.$id.',form_input.day_'.$id.',form_input.hour_'.$id.',form_input.minute_'.$id.',this)">'; 
		}
		$str_return = $day . $bulan . $tahun . $hour . $minute;
		$str_return .= $button;
		return $str_return;
	}
	
	// keterangan nilai
	
	private function DisplayListNilai(){
		// default point
		$result = $this->obj_cpd_engine->GetDataAsSingleArray("GetDetailFormById", array($this->arr_routes['params'][2], $this->int_id_form));
		$this->obj_tmpl->addGlobalVar('NILAI', $result['default_point']);
		// tabel keterangan nilai
		$params = array($this->int_id_form);
		$rs_id = $this->obj_cpd_engine->GetResourceId("GetListNilaiByIdForm", $params);
		$no = 0;
		if($rs_id){
			while($rs = mysql_fetch_assoc($rs_id)){
				$this->obj_tmpl->addVar('list_nilai', 'ID', $rs['id_nilai']);
				$str_list = self::GetNameEngine($rs['group_elemen_list']);
				$this->obj_tmpl->addVar('list_nilai', 'GROUP', $str_list);
				$this->obj_tmpl->addVar('list_nilai', 'NILAI', $rs['nilai_skp']);
				$this->obj_tmpl->addVar('list_nilai', 'INDEX', $no);			
				$this->obj_tmpl->ParseTemplate('list_nilai', 'a');
				$no++;
			}
			$this->obj_tmpl->addVar('content', 'TOTAL_DATA', $no);
		}
	}
	
	private function GetNameEngine($group){
		$group = explode(',', $group);
		$str = "";
		$no = 0;
		foreach($group as $val){
			$rs = $this->obj_cpd_engine->GetDataAsSingleArray("GetElemenListNameById", array($val));
			$str .= "<td>" . $rs['list_name'] . "</td>";
			$no++;
		}
		$this->obj_tmpl->addVar('content', 'COLSPAN', $no);
		return $str;
	}
}

?>