<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// object definition
	protected $obj_cpd;
	protected $obj_date;
	protected $obj_notify;
	// variable
	protected $int_person = 0;	
	protected $int_periode = 0;	
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		// load business
		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);
		$loaded_query = array('catatan');
		$this->obj_cpd->SetUsesQuery($loaded_query);
		// --
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');		
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');		
	}
	
	public function PageView(){
		// display test cookies
		self::DisplayNotification();
		// Display Url Link and Variable
		self::DisplayVariable();
		// Display identitas anggota
		self::DisplayDetailPerson();
		// Display list periode
		self::DisplayListPeriode();
		
		// display content
		self::DisplayViewContent();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	private function DisplayNotification(){
		// get session for start notification
		$this->obj_notify->GetMessage();
		// display message	
		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');
		// display last filled	
		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'display');
		// clear session when finish
		$this->obj_notify->ClearSession();
		
		// javascript loaded
		$this->obj_ctrl->LoadJavascript('dhtmlgoodies_calendar');
		// dhtmlgoodies_calendar loaded
		$this->obj_ctrl->LoadStyle('dhtmlgoodies_calendar', 'dhtmlgoodies_calendar');
		// dhtmlgoodies_calendar loaded body event
		$this->obj_ctrl->LoadEventOnBody("onload", "SetDhtmlgoodiesPathImages('".HTTPPATH."application/themes/dhtmlgoodies_calendar/img/');");
	}
	
	private function DisplayVariable(){
		// variable routes
		if(isset($this->arr_routes['params'][0]) AND !empty($this->arr_routes['params'][0])){
			$this->int_person = $this->arr_routes['params'][0];
			$this->obj_tmpl->addVar('display', 'ID_PERSON', $this->int_person);
		}
		if(isset($this->arr_routes['params'][1]) AND !empty($this->arr_routes['params'][1])){
			$this->int_periode = $this->arr_routes['params'][1];
			$this->obj_tmpl->addVar('display', 'ID_PERIODE', $this->int_periode);
		}
		
		// person
		if(isset($this->arr_routes['params'][0])){
			$this->str_person = $this->arr_routes['params'][0];
			$this->obj_tmpl->addVar('content', 'ID_PERSON', $this->str_person);
		}
		// page link
		
		$this->obj_tmpl->addVar('content', 'URL_ANGGOTA', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'anggota'));
		$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array($this->arr_routes['params'][0], $this->arr_routes['params'][1], 'add')));
		$this->obj_tmpl->addVar('content', 'URL_STR', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'periode', array($this->arr_routes['params'][0])));
		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page'], array($this->arr_routes['params'][0], $this->arr_routes['params'][1])));
		$this->obj_tmpl->addVar('display', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));
		// total
		$total = $this->obj_cpd->GetDataAsSingleArray("GetTotalCatatanByPerson", array($this->arr_routes['params'][0], $this->int_periode));
		$this->obj_tmpl->addVar('content', 'TOTAL_CATATAN', $total['total']);
	}
	
	private function DisplayListPeriode(){
		$rs_id = $this->obj_cpd->GetResourceId("GetListPeriodeByPerson", array($this->str_userid));
		if($rs_id){
			$temp = "";
			while($rec = mysql_fetch_assoc($rs_id)){
				if(empty($tmp) AND empty($this->int_periode)){ $this->int_periode = $rec['id_periode']; $tmp = true;}
				// selected
				if($rec['id_periode'] == $this->int_periode)
					$this->obj_tmpl->addVar('list_periode', 'SELECTED', 'selected="selected"');	
				else
					$this->obj_tmpl->addVar('list_periode', 'SELECTED', '');				
				// parse
				$this->obj_tmpl->addVar('list_periode', 'VALUE', $rec['id_periode']);	
				$label = $this->obj_date->GetFullDate($rec['tgl_mulai'], 'ins') .' s/d '. $this->obj_date->GetFullDate($rec['tgl_selesai'], 'ins');
				$this->obj_tmpl->addVar('list_periode', 'LABEL', $label);	
				$this->obj_tmpl->parseTemplate('list_periode', 'a');	
			}
		}
	}
	
	private function DisplayDetailPerson(){
		$result = $this->obj_cpd->GetDataAsSingleArray("GetDetailAnggotaByIdPerson", array($this->arr_routes['params'][0]));
		if(!empty($result)){			
			$this->obj_tmpl->addVar('content', 'PREFIX', $result['prefix']);
			$this->obj_tmpl->addVar('content', 'SUFFIX', $result['suffix']);
			$this->obj_tmpl->addVar('content', 'NAMA_LENGKAP', $result['nama_lengkap']);
			$this->obj_tmpl->addVar('content', 'ALAMAT', $result['alamat']);
			$this->obj_tmpl->addVar('content', 'KOTA', $result['kota']);
			$this->obj_tmpl->addVar('content', 'CABANG', $result['cabang']);
			$this->obj_tmpl->addVar('content', 'NO_ANGGOTA', $result['no_anggota']);
			// display foto
			$path = "doc/person/".$result['id_person']."/foto/".$result['photo'];
			if(is_file($path))
				$this->obj_tmpl->addVar('content', 'FOTO', $path);
			else
				$this->obj_tmpl->addVar('content', 'FOTO', "doc/temp/blank.jpg");			
		}else{
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'anggota');	
		}
	}
	
	private function DisplayViewContent(){
		if(isset($this->arr_routes['params'][2])){
			if($this->arr_routes['params'][2] == 'add'){
				// Display list dokumen
				self::DisplayAddForm();
			}
			if($this->arr_routes['params'][2] == 'edit'){
				// Display list dokumen
				self::DisplayEditForm();
			}
		}else{
			// Display list dokumen
			self::DisplayListData();
		}
	}
	
	private function DisplayListData(){
		// --
		$rs_id = $this->obj_cpd->GetResourceId("GetListCatatanByPerson", array($this->arr_routes['params'][0], $this->int_periode));
		if($rs_id){
			$no = 1;
			while($rec = mysql_fetch_assoc($rs_id)){
				// download
		$url_download = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], 'surat_etik', 'download', array($this->str_person, $this->int_periode, $rec['id_catatan']));
				$url_edit = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'etik', array($this->arr_routes['params'][0], $this->int_periode, 'edit', $rec['id_catatan']));
				// --
				$this->obj_tmpl->addVar('list_data', 'NO', $no);
				$this->obj_tmpl->addVar('list_data', 'ID', $rec['id_catatan']);
				$this->obj_tmpl->addVar('list_data', 'JUDUL', $rec['judul']);
				$this->obj_tmpl->addVar('list_data', 'PEMERIKSA', self::GetDataPemeriksa($rec['mdb']));	
				$this->obj_tmpl->addVar('list_data', 'URL_EDIT', $url_edit);
				$this->obj_tmpl->addVar('list_data', 'URL_DOWNLOAD', $url_download);	
				$this->obj_tmpl->addVar('list_data', 'TANGGAL', $this->obj_date->GetFullDate($rec['mdd'], 'in'));	
				$this->obj_tmpl->parseTemplate('list_data', 'a');	
				$no++;
				
			}
		}
	}
	
	private function DisplayAddForm(){
		$this->obj_tmpl->addVar('display', 'view', 'add');
		$result = $this->obj_cpd->GetDataAsSingleArray("GetKomisiEtikSetting", array($this->int_periode));
		if(!empty($result)){
			$this->obj_tmpl->AddVar('display', 'PERIHAL', $result['perihal']);
			$this->obj_tmpl->AddVar('display', 'LAMPIRAN', $result['lampiran']);
			$this->obj_tmpl->AddVar('display', 'TMP_TERBIT', $result['tempat']);
			$this->obj_tmpl->AddVar('display', 'KETUA', $result['ketua']);
			$this->obj_tmpl->AddVar('display', 'IMG', $result['img']);
			
			// add
			$this->obj_tmpl->AddVar('display', 'ACTION', 'insert_surat_komisi');
			$t = date('Y');
			$b = date('m');
			$h = date('d');
			$this->obj_date->SetPatTemplates($this->obj_tmpl);
			$this->obj_date->DhtmlgoodiesStandardDate('list_year', 'list_month', 'list_day', $t, $b, $h, date('Y')-6, date('Y'));
		
			}
		
		
	}
	
	
	private function DisplayEditForm(){
		$this->obj_tmpl->addVar('display', 'view', 'edit');
		// --
		$result = $this->obj_cpd->GetDataAsSingleArray("GetDetailCatatanByParams", array($this->arr_routes['params'][0], $this->int_periode, $this->arr_routes['params'][3]));
		if(!empty($result)){
			$this->obj_tmpl->addVar('display', 'ID_CATATAN', $result['id_catatan']);
			$this->obj_tmpl->addVar('display', 'NOMOR_SURAT', $result['nomor_surat']);
			$this->obj_tmpl->addVar('display', 'LAMPIRAN2', $result['lampiran']);
			$this->obj_tmpl->addVar('display', 'JUDUL', $result['judul']);
			$this->obj_tmpl->addVar('display', 'DESKRIPSI', $result['keterangan']);
			$this->obj_tmpl->addVar('display', 'PEMERIKSA', self::GetDataPemeriksa($result['mdb']));	
			$this->obj_tmpl->addVar('display', 'TANGGAL', $this->obj_date->GetFullDate($result['mdd'], 'in'));
			$this->obj_tmpl->addVar('display', $result['downloaded'], 'selected="selected"');	
			//$this->obj_tmpl->addVar('display', 'TMP_TERBIT', self::DisplayDefaultKomisiEtik($result['tempat']));
			//$this->obj_tmpl->addVar('display', 'KETUA', self::DisplayDefaultKomisiEtik($result['ketua']));
			
			$tgl = explode('-', $result['tgl_terbit']);
			$t = $tgl[0];
			$b = $tgl[1];
			$h = $tgl[2];
			$this->obj_date->SetPatTemplates($this->obj_tmpl);
			$this->obj_date->DhtmlgoodiesStandardDate('list_year1', 'list_month1', 'list_day1', $t, $b, $h, date('Y')-5, date('Y'));
			
			$result = $this->obj_cpd->GetDataAsSingleArray("GetKomisiEtikSetting", array());
		if(!empty($result)){
			$this->obj_tmpl->AddVar('display', 'PERIHAL', $result['perihal']);
			$this->obj_tmpl->AddVar('display', 'LAMPIRAN', $result['lampiran']);
			$this->obj_tmpl->AddVar('display', 'TMP_TERBIT', $result['tempat']);
			$this->obj_tmpl->AddVar('display', 'KETUA', $result['ketua']);
			
			
		}
		}
	}
	
	private function DisplayDefaultKomisiEtik(){
		$result = $this->obj_cpd->GetDataAsSingleArray("GetKomisiEtikSetting", array());
		if(!empty($result)){
			$this->obj_tmpl->AddVar('content', 'PERIHAL', $result['perihal']);
			$this->obj_tmpl->AddVar('content', 'LAMPIRAN', $result['lampiran']);
			$this->obj_tmpl->AddVar('content', 'TMP_TERBIT', $result['tempat']);
			$this->obj_tmpl->AddVar('content', 'KETUA', $result['ketua']);
		}
	}
	
	// utility
	
	private function GetDataPemeriksa($person){
		$rs = $this->obj_cpd->GetDatasetAsArray("GetNamaLengkapByPerson", array($person));
		if(!empty($rs)){
			$label = $rs[0]['prefix'] . ' ' . $rs[0]['nama_lengkap'] . ' ' . $rs[0]['suffix'];
		}else{
			$label = "-";
		}
		return $label;
	}
}

?>