<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// object definition
	protected $obj_cpd;
	protected $obj_notify;
	// variable definition
	protected $arr_params;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		
	}		
	
	protected function ParseDocumentOutput(){
		/** Redirect result to default page */
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'], 'anggota');	
	}
	
	protected function PageLoad(){ 
		/* -- Other object loaded below */
		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);
		$loaded_query = array('catatan');
		$this->obj_cpd->SetUsesQuery($loaded_query);
		// --
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');
	}
	
	public function PageView(){
		// important to encypte bug post form
		if(isset($_POST['save'])){ 
			$action = array_keys($_POST['save']); 
			$this->arr_params = $_POST;
			unset($_POST);
		}else{
			$action = FALSE;
		}
		// controller to manage process that page requested
		switch($action[0]){
			case 'search':
				self::SearchData();
				break;
			case 'insert':
				self::InsertCatatanEtik();
				break;
			case 'update':
				self::UpdateCatatanEtik();
				break;
			case 'hapus':
				self::HapusCatatanEtik();
				break;
			default:
				break;
		}
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	// notification method
	private function SendNotification($err, $filled, $msg, $type){
		$this->obj_notify->ClearSession();
		$this->obj_notify->SetHeaderMessage($type, $msg);
		// error send
		foreach($err as $val){
			$this->obj_notify->SetMessage($val);
		}		
		// field value history
		for($i=0;$i<count($filled);$i++){
			$name = array_keys($filled);
			$this->obj_notify->SetField($name[$i], $filled[$name[$i]]);
		}
		$this->obj_notify->SentMessage();
	}
	
	// search method
	private function SearchData(){
		$_SESSION['search']['catatan']['wilayah'] = $this->arr_params['id_wilayah'];
		$_SESSION['search']['catatan']['nama'] = $this->arr_params['keyword'];
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'anggota');
	}
	
	// operation
	private function InsertCatatanEtik(){
		// check / validate parameter 
		$err = array();	
		$filled = array();	
		// required
		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><strong>Anggota</strong> tidak terpilih'; }
		if(empty($this->arr_params['id_periode'])){ $err[] = '<br /><strong>Periode</strong> tidak terpilih'; }
		if(empty($this->arr_params['judul'])){ $err[] = '<br /><strong>Judul</strong> harus diisi'; }
		if(empty($this->arr_params['keterangan'])){ $err[] = '<br /><strong>Keterangan</strong> harus diisi'; }
		// processing --------------------------------------------------
		if(empty($err)){
			$params = array($this->arr_params['id_periode'], $this->arr_params['judul'], $this->arr_params['keterangan'], $this->str_userid);
			// processing
			if($this->obj_cpd->ProcessingData("InsertCatatanEtik", $params)){
				// notification message			
				self::SendNotification($err, $filled, 'Data telah disimpan.', 'success');
				// redirect to success page ------------------------------------
			}else{
				// error message
				self::SendNotification($err, $filled, 'Business process failure.', 'error');
				// redirect to page error page ------------------------------------		
			}			
		}else{			
			// error message
			self::SendNotification($err, $filled, 'See Input Requirements.', 'error');
			// redirect to page error page ------------------------------------		
		}
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'etik', array($this->arr_params['id_person'], $this->arr_params['id_periode'], 'add'));
	}	
	
	private function UpdateCatatanEtik(){
		// check / validate parameter 
		$err = array();	
		$filled = array();	
		// required
		if(empty($this->arr_params['id_catatan'])){ $err[] = '<br /><strong>ID catatan</strong> tidak terpilih'; }
		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><strong>Anggota</strong> tidak terpilih'; }
		if(empty($this->arr_params['id_periode'])){ $err[] = '<br /><strong>Periode</strong> tidak terpilih'; }
		if(empty($this->arr_params['judul'])){ $err[] = '<br /><strong>Judul</strong> harus diisi'; }
		if(empty($this->arr_params['keterangan'])){ $err[] = '<br /><strong>Keterangan</strong> harus diisi'; }
		// processing --------------------------------------------------
		if(empty($err)){
			$params = array($this->arr_params['id_periode'], $this->arr_params['judul'], $this->arr_params['keterangan'], $this->str_userid, $this->arr_params['id_person'], $this->arr_params['id_catatan']);
			// processing
			if($this->obj_cpd->ProcessingData("UpdateCatatanEtik", $params)){
				// notification message			
				self::SendNotification($err, $filled, 'Data telah disimpan.', 'success');
				// redirect to success page ------------------------------------
			}else{
				// error message
				self::SendNotification($err, $filled, 'Business process failure.', 'error');
				// redirect to page error page ------------------------------------		
			}			
		}else{			
			// error message
			self::SendNotification($err, $filled, 'See Input Requirements.', 'error');
			// redirect to page error page ------------------------------------		
		}
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'etik', array($this->arr_params['id_person'], $this->arr_params['id_periode'], 'edit', $this->arr_params['id_catatan']));
	}	
	
	private function HapusCatatanEtik(){
		// check / validate parameter 
		$err = array();	
		$filled = array();	
		// required
		if(empty($this->arr_params['id_person'])){ $err[] = '<br /><strong>Anggota</strong> tidak terpilih'; }
		if(empty($this->arr_params['id_periode'])){ $err[] = '<br /><strong>Periode</strong> tidak terpilih'; }
		if(empty($this->arr_params['downcheck'])){ $err[] = '<br /><strong>ID catatan</strong> tidak terpilih'; }
		// processing --------------------------------------------------
		if(empty($err)){
			// processing
			foreach($this->arr_params['downcheck'] as $id){
				$this->obj_cpd->ProcessingData("HapusCatatanEtik", array($this->arr_params['id_person'], $id));
			}	
			// error message
			self::SendNotification($err, $filled, 'Data telah terhapus.', 'success');
			// redirect to page error page ------------------------------------		
		}else{			
			// error message
			self::SendNotification($err, $filled, 'See Input Requirements.', 'error');
			// redirect to page error page ------------------------------------		
		}
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'etik', array($this->arr_params['id_person'], $this->arr_params['id_periode']));
	}	
}

?>