<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// object definition
	protected $obj_dok;
	protected $obj_date;
	protected $obj_notify;
	// variable
	protected $int_periode = 0;	
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		// load business
		$this->obj_dok = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);
		$loaded_query = array('dokumen');
		$this->obj_dok->SetUsesQuery($loaded_query);
		// --
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');		
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');		
	}
	
	public function PageView(){
		// display test cookies
		self::DisplayNotification();
		// Display Url Link and Variable
		self::DisplayVariable();
		// Display list periode
		self::DisplayListPeriode();
		// Display list dokumen
		self::DisplayListData();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	private function DisplayNotification(){
		// get session for start notification
		$this->obj_notify->GetMessage();
		// display message	
		$this->obj_notify->DisplayMessage($this->obj_tmpl, 'notification', 'list_notify');
		// display last filled	
		$this->obj_notify->DisplayLastField($this->obj_tmpl, 'display');
		// clear session when finish
		$this->obj_notify->ClearSession();
	}
	
	private function DisplayVariable(){
		$this->obj_tmpl->addVar('content', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));
		$this->obj_tmpl->addVar('content', 'URL_ADD', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'upload'));
		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'bukti'));
	}
	
	private function DisplayListPeriode(){
		if(isset($this->arr_routes['params'][0]) AND !empty($this->arr_routes['params'][0])){
			$this->int_periode = $this->arr_routes['params'][0];
		}
		$rs_id = $this->obj_dok->GetResourceId("GetListPeriodeByPerson", array($this->str_userid));
		if($rs_id){
			$temp = "";
			while($rec = mysql_fetch_assoc($rs_id)){
				if(empty($tmp) AND empty($this->int_periode)){ $this->int_periode = $rec['id_periode']; $tmp = true;}
				// selected
				if($rec['id_periode'] == $this->int_periode)
					$this->obj_tmpl->addVar('list_periode', 'SELECTED', 'selected="selected"');	
				else
					$this->obj_tmpl->addVar('list_periode', 'SELECTED', '');				
				// parse
				$this->obj_tmpl->addVar('list_periode', 'VALUE', $rec['id_periode']);	
				$label = $this->obj_date->GetFullDate($rec['tgl_mulai'], 'ins') .' s/d '. $this->obj_date->GetFullDate($rec['tgl_selesai'], 'ins');
				$this->obj_tmpl->addVar('list_periode', 'LABEL', $label);	
				$this->obj_tmpl->parseTemplate('list_periode', 'a');	
			}
		}else{
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], 'rencana', 'diri');
		}
	}
	
	private function DisplayListData(){
		$this->obj_tmpl->addVar('content', 'TOTAL_DOKUMEN', 0);
		$rs_id = $this->obj_dok->GetResourceId("GetListDokumenByPerson", array($this->str_userid, $this->int_periode));
		if($rs_id){
			$no = 1;
			while($rec = mysql_fetch_assoc($rs_id)){
				// crypt id
				//$url_download = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'download-lampiran', array(sha1(md5($this->str_userid)), md5(sha1($rec['id']))));
				$url_download = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'download-lampiran', array($this->str_userid, $rec['id']));
				// --
				$url_edit = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($rec['id']));
				$url_hapus = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'hapus', array($rec['id']));
				$this->obj_tmpl->addVar('list_data', 'NO', $no);
				$this->obj_tmpl->addVar('list_data', 'JUDUL', $rec['judul']);	
				$this->obj_tmpl->addVar('list_data', 'DESKRIPSI', $rec['deskripsi']);
				$this->obj_tmpl->addVar('list_data', 'PEMERIKSA', self::GetDataPemeriksa($rec['verifikator']));	
				$this->obj_tmpl->addVar('list_data', 'TGL_PERIKSA', $this->obj_date->GetFullDate($rec['tgl_verifikasi']));
				$this->obj_tmpl->addVar('list_data', 'URL_DOWNLOAD', $url_download);	
				$this->obj_tmpl->addVar('list_data', 'URL_EDIT', $url_edit);	
				$this->obj_tmpl->addVar('list_data', 'URL_HAPUS', $url_hapus);	
				$this->obj_tmpl->addVar('list_data', 'TANGGAL', $this->obj_date->GetFullDate($rec['tgl_dokumen'], 'in'));	
				switch($rec['evaluated']){
					case 'no':
						$status_verifikasi = '<img src="'.HTTPPATH."doc/temp/redin-ico.jpg".'" title="Rejected" />';
						break;
					case 'yes':
						$status_verifikasi = '<img src="'.HTTPPATH."doc/temp/greedin-ico.jpg".'" title="Accepted" />';
						break;
					default :
						$status_verifikasi = '<img src="'.HTTPPATH."doc/temp/orangin-ico.jpg".'" title="Waiting" />';
						break;
				}
				$this->obj_tmpl->addVar('list_data', 'EVALUATED', $status_verifikasi);
				$this->obj_tmpl->parseTemplate('list_data', 'a');	
				$no++;
			}
			$this->obj_tmpl->addVar('content', 'TOTAL_DOKUMEN', $no - 1);
		}
	}
	
	private function GetDataPemeriksa($person){
		$rs = $this->obj_dok->GetDatasetAsArray("GetDataPemeriksaByPerson", array($person));
		if(!empty($rs)){
			$label = $rs[0]['prefix'] . ' ' . $rs[0]['nama_lengkap'] . ' ' . $rs[0]['suffix'] . '<br>' . $rs[0]['nama'];
		}else{
			$label = "-";
		}
		return $label;
	}
}

?>