<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// object definition
	protected $obj_dok;
	protected $obj_notify;
	protected $obj_upload;
	// variable definition
	protected $arr_params;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		
	}		
	
	protected function ParseDocumentOutput(){
		/** Redirect result to default page */
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'],$this->arr_routes['group'],$this->arr_routes['module'], 'bukti');	
	}
	
	protected function PageLoad(){ 
		/* -- Other object loaded below */
		$this->obj_dok = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);
		$loaded_query = array('dokumen');
		$this->obj_dok->SetUsesQuery($loaded_query);
		// --
		$this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');
		$this->obj_upload = $this->obj_ctrl->LoadLibrary('Uploader');
	}
	
	public function PageView(){
		// important to encypte bug post form
		if(isset($_POST['save'])){ 
			$action = array_keys($_POST['save']); 
			$this->arr_params = $_POST;
			unset($_POST);
		}else{
			$action = FALSE;
		}
		// controller to manage process that page requested
		switch($action[0]){
			case 'insert':
				self::InsertLampiranDokumen();
				break;
			case 'update':
				self::UpdateLampiranDokumen();
				break;
			case 'hapus':
				self::HapusLampiranDokumen();
				break;
			default:
				break;
		}
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	// notification method
	private function SendNotification($err, $filled, $msg, $type){
		$this->obj_notify->ClearSession();
		$this->obj_notify->SetHeaderMessage($type, $msg);
		// error send
		foreach($err as $val){
			$this->obj_notify->SetMessage($val);
		}		
		// field value history
		for($i=0;$i<count($filled);$i++){
			$name = array_keys($filled);
			$this->obj_notify->SetField($name[$i], $filled[$name[$i]]);
		}
		$this->obj_notify->SentMessage();
	}
	
	// operation
	private function InsertLampiranDokumen(){
		// check / validate parameter 
		$err = array();	
		$filled = array();	
		// required
		$this->arr_params['dokumen'] = $_FILES['dokumen'];
		if(empty($this->arr_params['id_periode'])){ $err[] = '<br /><strong>Periode</strong> tidak terpilih'; }
		if(empty($this->arr_params['judul'])){ $err[] = '<br /><strong>Judul</strong> harus diisi'; }
		if(empty($this->arr_params['keterangan'])){ $err[] = '<br /><strong>Keterangan</strong> harus diisi'; }
		$tgl = $this->arr_params['year'].'-'.$this->arr_params['month'].'-'.$this->arr_params['day'];
		// get id
		$last_id = $this->obj_dok->GetDatasetAsArray("GetLastIdDokumen", array());
		$id_dok = intval($last_id[0]['last_id']) + 1;
		// upload dokumen			
		if(!empty($this->arr_params['dokumen']['tmp_name']) AND empty($err)){
			// allowed type
			$this->obj_upload->file_accept = array('doc', 'docx', 'xls', 'xlsx', 'pdf', 'ppt', 'zip', 'gif', 'jpeg', 'jpg', 'jpe', 'png', 'bmp', 'tiff', 'tif', 'txt', 'text', 'rtf', 'rtx', 'xsl', 'word', 'xl', 'log');
			// name and path file
			$file_name = str_replace(' ', '_', $this->arr_params['dokumen']['name']);
			$file_path = "doc/person/".$this->str_userid."/lampiran/".$id_dok."/";
			// processing
			if(!$this->obj_upload->FileUpload($this->arr_params['dokumen'], $file_path)){
				$err[] = '<br />'.$file_name.' <strong>tidak berhasil</strong> diupload'; 
			}
		}else{
			$err[] = '<br /><strong>Dokumen</strong> harus diisi';
		}
		// processing --------------------------------------------------
		if(empty($err)){
			$params = array($id_dok, $this->arr_params['id_periode'], $this->arr_params['judul'], $this->arr_params['keterangan'], $file_name, $file_path, $tgl, $this->str_userid);
			// processing
			if($this->obj_dok->ProcessingData("InsertLampiranDokumen", $params)){
				// save history
				$history['user'] = $this->str_userid;
				$history['target'] = "member";
				$history['title'] = "Upload lampiran dokumen PKB";
				$history['deskripsi'] = $this->arr_params['judul'];
				$history['url_title'] = "Lampiran Dokumen PKB";
				$history['url_link'] = HTTPPATH . "index.php/private/cpd/dokumen-bukti/";
				$this->obj_dok->AddActivitiesHistory($history);
				// notification message			
				self::SendNotification($err, $filled, 'Data telah disimpan.', 'success');
				// redirect to success page ------------------------------------
			}else{
				// unlink uploaded file
				if(is_dir($file_path)){ $this->obj_upload->RemoveDir($file_path);}
				// error message
				self::SendNotification($err, $filled, 'Business process failure.', 'error');
				// redirect to page error page ------------------------------------		
			}			
		}else{			
			// error message
			self::SendNotification($err, $filled, 'See Input Requirements.', 'error');
			// redirect to page error page ------------------------------------		
		}
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'upload');
	}	
	
	private function UpdateLampiranDokumen(){
		// check / validate parameter 
		$err = array();	
		$filled = array();	
		// required
		$this->arr_params['dokumen'] = $_FILES['dokumen'];
		if(empty($this->arr_params['id'])){ $err[] = '<br /><strong>ID</strong> tidak terpilih'; }
		if(empty($this->arr_params['id_periode'])){ $err[] = '<br /><strong>Periode</strong> tidak terpilih'; }
		if(empty($this->arr_params['judul'])){ $err[] = '<br /><strong>Judul</strong> harus diisi'; }
		if(empty($this->arr_params['keterangan'])){ $err[] = '<br /><strong>Keterangan</strong> harus diisi'; }
		$tgl = $this->arr_params['year'].'-'.$this->arr_params['month'].'-'.$this->arr_params['day'];
		// get id
		$id_dok = $this->arr_params['id'];
		// upload dokumen			
		if(!empty($this->arr_params['dokumen']['tmp_name']) AND empty($err)){
			$no_file = false;
			// allowed type
			$this->obj_upload->file_accept = array('doc', 'docx', 'xls', 'xlsx', 'pdf', 'ppt', 'zip', 'gif', 'jpeg', 'jpg', 'jpe', 'png', 'bmp', 'tiff', 'tif', 'txt', 'text', 'rtf', 'rtx', 'xsl', 'word', 'xl', 'log');
			// name and path file
			$file_name = str_replace(' ', '_', $this->arr_params['dokumen']['name']);
			$file_path = "doc/person/".$this->str_userid."/lampiran/".$id_dok."/";
			// processing
			if(!$this->obj_upload->FileUpload($this->arr_params['dokumen'], $file_path)){
				$err[] = '<br />'.$file_name.' <strong>tidak berhasil</strong> diupload'; 
			}
		}else{
			$no_file = true;
		}
		// processing --------------------------------------------------
		if(empty($err)){
			if($no_file){
				$exec_query = "UpdateLampiranDokumenNoFile";
				$params = array($this->arr_params['id_periode'], $this->arr_params['judul'], $this->arr_params['keterangan'], $tgl, $this->str_userid, $this->str_userid, $id_dok);
			}else{
				$exec_query = "UpdateLampiranDokumen";
				$params = array($this->arr_params['id_periode'], $this->arr_params['judul'], $this->arr_params['keterangan'], $file_name, $file_path, $tgl, $this->str_userid, $this->str_userid, $id_dok);
			}
			// processing
			if($this->obj_dok->ProcessingData($exec_query, $params)){
				// save history
				$history['user'] = $this->str_userid;
				$history['target'] = "member";
				$history['title'] = "Revisi lampiran dokumen PKB";
				$history['deskripsi'] = $this->arr_params['judul'];
				$history['url_title'] = "Lampiran Dokumen PKB";
				$history['url_link'] = HTTPPATH . "index.php/private/cpd/dokumen-bukti/";
				$this->obj_dok->AddActivitiesHistory($history);
				// notification message			
				self::SendNotification($err, $filled, 'Data telah disimpan.', 'success');
				// redirect to success page ------------------------------------
			}else{
				// error message
				self::SendNotification($err, $filled, 'Business process failure.', 'error');
				// redirect to page error page ------------------------------------		
			}			
		}else{			
			// error message
			self::SendNotification($err, $filled, 'See Input Requirements.', 'error');
			// redirect to page error page ------------------------------------		
		}
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($id_dok));
	}	
	
	private function HapusLampiranDokumen(){
		// check / validate parameter 
		$err = array();	
		$filled = array();	
		// required
		if(empty($this->arr_params['id'])){ $err[] = '<br /><strong>ID</strong> tidak terpilih'; }
		// get detail
		$result = $this->obj_dok->GetDatasetAsArray("GetDetailDokumenByPerson", array($this->str_userid, $this->arr_params['id']));
		// processing --------------------------------------------------
		if(empty($err)){
			// processing
			if($this->obj_dok->ProcessingData("HapusLampiranDokumen", array($this->str_userid, $this->arr_params['id']))){
				// unlink uploaded file
				if(is_dir($result[0]['file_path'])){ $this->obj_upload->RemoveDir($result[0]['file_path']);}
				// save history
				$history['user'] = $this->str_userid;
				$history['target'] = "member";
				$history['title'] = "Menghapus lampiran dokumen PKB";
				$history['deskripsi'] = $result[0]['judul'];
				$history['url_title'] = "Lampiran Dokumen PKB";
				$history['url_link'] = HTTPPATH . "index.php/private/cpd/dokumen-bukti/";
				$this->obj_dok->AddActivitiesHistory($history);
				// notification message			
				self::SendNotification($err, $filled, 'Data telah dihapus.', 'success');
				// redirect to success page ------------------------------------
				$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'bukti');
			}else{
				// error message
				self::SendNotification($err, $filled, 'Business process failure.', 'error');
				// redirect to page error page ------------------------------------		
			}			
		}else{			
			// error message
			self::SendNotification($err, $filled, 'See Input Requirements.', 'error');
			// redirect to page error page ------------------------------------		
		}
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'edit', array($id_dok));
	}	
}

?>