<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// object definition
	protected $obj_cpd;
	// variable definition
	protected $arr_params;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		
	}		
	
	protected function ParseDocumentOutput(){
		/** Redirect result to default page */
		// pdf	
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		/* Other object loaded below */
		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);
		$loaded_query = array('evaluasi', 'kegiatan', 'str');
		$this->obj_cpd->SetUsesQuery($loaded_query);
		// -- 
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');
		// load plugins
		$this->obj_ctrl->LoadFile('tcpdf/tcpdf.php', 'plugins');
		$this->obj_tcpdf = $this->obj_ctrl->LoadClass('TCPDF');
	}
	
	public function PageView(){
		// display pdf download
		self::DownloadSuratRekomendasi();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
		
	// operation
	private function DownloadSuratRekomendasi(){
		$person = $this->obj_cpd->GetDataAsSingleArray("GetDetailAnggotaByIdPerson", array($this->arr_routes['params'][0]));
		$path = "doc/temp/blank.jpg";
		if(!empty($person)){
			// display foto
			$path = "doc/person/".$person['id_person']."/foto/".$person['photo'];
			if(!is_file($path))
				$path = "doc/temp/blank.jpg";
		}
		// parse data
		$rekomendasi = $this->obj_cpd->GetDataAsSingleArray("GetSuratRekomendasiByStr", array($this->arr_routes['params'][0], $this->arr_routes['params'][1]));
		// parse data skp
		$skp_total = 0;
		$formulas = 250 / 150;
		$rs_id = $this->obj_cpd->GetResourceId("GetListPeriodeKegiatanById", array($this->arr_routes['params'][1], $this->arr_routes['params'][0]));
		if($rs_id){
			while($rec = mysql_fetch_assoc($rs_id)){
				// get nilai per tahun
				// get nilai by params 
				$nilai = self::GetNilaiByTanggal($this->arr_routes['params'][0], $rec['tgl_mulai'], $rec['tgl_selesai']);
				$skp_total = $skp_total + $nilai;
			}
		}
				$skp_ikafmi_total = number_format($skp_total, 0, ',', '');
				//$this->obj_tmpl->addVar('display', 'TOTAL_PERTAHUN_ALL', $skp_ikafmi_total);
				$skp_konversi_total = $skp_total * $formulas;
				$skp_konversi_total = number_format($skp_konversi_total, 0, ',', '');
				//$this->obj_tmpl->addVar('display', 'TOTAL_PERTAHUN_KONVERSI', $skp_konversi_total);	
		// print pdf
		$this->obj_tcpdf->setPrintHeader(false);
		$this->obj_tcpdf->setPrintFooter(false);
		$this->obj_tcpdf->SetDisplayMode('real');
		$this->obj_tcpdf->SetMargins(10, 10);		
		// add a page
		$this->obj_tcpdf->AddPage();	
		$this->obj_tcpdf->SetFont("arial", "BI", 10);	
		// create some HTML content
		$tablealign = '
<table border="none" width="100%" cellpadding="2">
  <tr>
    <td width="70" align="left"><img src="doc/temp/p2kb-logo.png" width="50" height="50" /></td>
    <td align="center" width="400"><b>KOMISI PENGEMBANGAN PENDIDIKAN KEPROFESIAN BERKELANJUTAN (PKB)<br />
     Persatuan Perawat Nasional Indonesia(PPNI)</b><br />
      <br />
      <font size="9">Sekretariat :RSCM, Lt.II G3, Jalan Diponegoro 71, Jakarta 10430,<br />
      Telp/Fax: 021-3909431, E-mail: p2kb_ppni@yahoo.com</font></td>
    <td width="70" align="right"><img src="doc/temp/logo-ppni.jpg" width="50" height="50" /></td>
  </tr>
</table>
<br />
<img src="doc/temp/hr.jpg" width="530" />
<br />
<br />
<table border="none" width="100%">
  <tr>
    <td colspan="3" align="center"><b>SURAT REKOMENDASI RE-SERTIFIKASI KOMPETENSI <br />KEPADA KOLEGIUM Persatuan Perawat Nasional Indonesia</b></td>
  </tr>
  <tr>
    <td colspan="3"></td>
  </tr>
  <tr>
    <td colspan="3"></td>
  </tr>
  <tr>
    <td width="50">No</td>
    <td width="15">:</td>
    <td>'.$rekomendasi['nomor_surat'].'</td>
  </tr>
  <tr>
    <td width="50">Hal</td>
    <td width="15">:</td>
    <td>'.$rekomendasi['perihal'].'</td>
  </tr>
  <tr>
	<td width="50">Lampiran</td>
    <td width="15">:</td>
    <td>'.$rekomendasi['lampiran'].'</td>
  </tr>
  <tr>
    <td colspan="3"></td>
  </tr>
  <tr>
    <td colspan="3"></td>
  </tr>
  <tr>
    <td colspan="3" align="left"> Kepada Yth,<br />
      Ketua Kolegium <br />
      Di<br />
      Jakarta</td>
  </tr>
  <tr>
    <td colspan="3"></td>
  </tr>
  <tr>
    <td colspan="3"></td>
  </tr>
  <tr>
    <td colspan="3">Yang bertanda tangan di bawah ini menerangkan bahwa :</td>
  </tr>
  <tr>
    <td colspan="3"></td>
  </tr>
  <tr>
    <td width="170">Nama</td>
    <td width="15">:</td>
    <td width="300">'.$person['prefix'].' '.$person['nama_lengkap'].' '.$person['suffix'].'</td>
  </tr>
  <tr>
    <td colspan="3"></td>
  </tr>
  <tr>
    <td width="170">Nomor anggota IDI</td>
    <td width="15">:</td>
    <td>'.$person['no_idi'].'</td>
  </tr>
  <tr>
    <td colspan="3"></td>
  </tr>
  <tr>
    <td width="170">Nomor anggota Persatuan Perawat Nasional Indonesia</td>
    <td width="15">:</td>
    <td>'.$person['no_anggota'].'</td>
  </tr>
  <tr>
    <td colspan="3"></td>
  </tr>
  <tr>
    <td width="170">Alamat</td>
    <td width="15">:</td>
    <td width="300">'.$person['alamat'].'</td>
  </tr>
  <tr>
    <td colspan="3"></td>
  </tr>
  <tr>
    <td  colspan="3">Jumlah SKP yang dicapai selama 5 tahun ('.$this->obj_date->GetFullDate($rekomendasi['tgl_mulai']).' s/d '.
	$this->obj_date->GetFullDate($rekomendasi['tgl_selesai']).') :<b> '.$skp_ikafmi_total.'</b><font size="9"> SKP Persatuan Perawat Nasional Indonesia </font> dan <b>'.$skp_konversi_total.'</b><font size="9"> SKP IDI</font></td>
  </tr>
  <tr>
    <td colspan="3"></td>
  </tr>
  <tr>
    <td colspan="3">Berdasarkan penilaian atas dokumen PKB, yang bersangkutan dinyatakan memenuhi syarat sehingga layak mendapat rekomendasi untuk memperoleh sertifikat kompetensi.</td>
  </tr>
  <tr>
    <td colspan="3"></td>
  </tr>
  <tr>
    <td colspan="3">'.$rekomendasi['tmp_terbit'].', '.$this->obj_date->GetFullDate($rekomendasi['tgl_terbit'], 'in').'</td>
  </tr>
  <tr>
    <td colspan="3">Ketua Komisi PKB Persatuan Perawat Nasional Indonesia</td>
  </tr>
  <tr>
    <td colspan="3" align="left"><img src="doc/temp/signature/tanda_tangan.jpg" /></td>
  </tr>
  <tr>
    <td colspan="3" align="left">'.$rekomendasi['ketua_komisi'].'</td>
  </tr>
</table>
';
		// output the HTML content
		$this->obj_tcpdf->writeHTML($tablealign, true, 0, true, 0);
		//Close and output PDF document
		$this->obj_tcpdf->Output("Surat-Rekomendasi-PKB.pdf", "D");
	}
	
	//get nilai skp
	private function GetNilaiByTanggal($id_person, $str_tgl_mulai, $str_tgl_selesai){
		$total = 0;
		// parameter
		$params = array($id_person, $str_tgl_mulai, $str_tgl_selesai);
		// get data
		$rs_id = $this->obj_cpd->GetResourceId("GetEvaluatedPKBGroupByForm", $params);
		// parse data
		if($rs_id){
			while($rec = mysql_fetch_assoc($rs_id)){
				// set ranah
				if(!isset($this->arr_ranah_all[$rec['ranah']])){$this->arr_ranah_all[$rec['ranah']] = '';}
				// get nilai skp
				if($rec['tipe'] == 'rutin')
					$nilai = self::GetNilaiSkpRutin($id_person, $rec['id_form'], $str_tgl_mulai, $str_tgl_selesai);
				else
					$nilai = $rec['nilai'];
				// tabel by ranah
				$this->arr_ranah_all[$rec['ranah']] = $this->arr_ranah_all[$rec['ranah']] + $nilai;		
				$total = $total + $nilai;
			}
		}
		return $total;
	}
	
	private function GetNilaiSkpRutin($id_person, $id_form, $str_tgl_mulai, $str_tgl_selesai){
		$nilai = 0;
		$jumlah = 0;
		// get parameter and indikator
		$arr = $this->obj_cpd->GetDataAsSingleArray("GetParameterAndEngineByForm", array($id_form, $id_form));
		$id_parameter = $arr['parameter'];
		$id_engine = $arr['indikator'];
		// get nilai dalam range tahun kegiatannya
		$rs_id = $this->obj_cpd->GetResourceId("GetDataKegiatanByFormDate", array($id_person, $id_form, $str_tgl_mulai, $str_tgl_selesai));
		if($rs_id){
			while($rec = mysql_fetch_assoc($rs_id)){
				$arr_field = "";
				$xml = simplexml_load_string($rec["data_kegiatan"]);
				// echo does the casting for you
				$count = count($xml->item);
				for($i=0;$i<$count;$i++){
					$id = intval($xml->item[$i]->idt);
					$value = strval($xml->item[$i]->value);
					if($id == $id_parameter){
						$jumlah = $jumlah + $value;
						break;
					}
				}
			}
		}
		// get list elemen
		$rs_id_list = $this->obj_cpd->GetResourceId("GetElemenListByEngine", array($id_engine));
		if($rs_id_list){
			$group_list = "FIND_IN_SET(0, group_elemen_list)";
			while($rec = mysql_fetch_assoc($rs_id_list)){
				$range_value = explode('-', $rec['list_value'], 2);
				if(sizeof($range_value) >= 2){
					$batas_bawah = round($range_value[0], 2);
					$batas_atas = round($range_value[1], 2);
				}else{
					$batas_bawah = 0;
					$batas_atas = 0;
				}	
				if($jumlah >= $batas_bawah AND $jumlah <= $batas_atas){
					$group_list = "FIND_IN_SET(".$rec['id_list'].", group_elemen_list)";
					break;
				}
			}
		}
		$nilai = $this->obj_cpd->GetDataAsSingleArray("GetNilaiSkpByEngine", array($group_list));	
		if(!empty($nilai))
			return $nilai['nilai_skp'];
		else
			return 0;
	}
	
}

?>