<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{		
	protected $obj_cpd;
	protected $obj_date;
	// variable definition
	protected $int_periode = '';
	protected $str_tgl_mulai;
	protected $str_tgl_selesai;
	protected $arr_ranah_all = array();
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		/* Other object loaded below */
		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);
		$loaded_query = array('evaluasi', 'kegiatan', 'str', 'dokumen');
		$this->obj_cpd->SetUsesQuery($loaded_query);
		// --
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	
	}
	
	public function PageView(){
		// display variable
		self::DisplayVariable();
		// display status kelayakan
		self::DisplayHasilEvaluasi();
		// display detail user
		self::DisplayDetailPerson();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	private function DisplayVariable(){
		// periode
		if(isset($this->arr_routes['params'][0])){
			$this->int_periode = $this->arr_routes['params'][0];
		}
		// top link
		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));
		$this->obj_tmpl->addVar('result', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));
		// sub link
		$this->obj_tmpl->addVar('content', 'URL_REKAPITULASI', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'evaluasi', array($this->int_periode)));
		$this->obj_tmpl->addVar('content', 'URL_PENILAIAN', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'penilaian', array($this->int_periode)));
		$this->obj_tmpl->addVar('content', 'URL_PKB', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'p2kb', array($this->int_periode)));
		$this->obj_tmpl->addVar('content', 'URL_SURAT', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'rekomendasi', array($this->int_periode)));
		// 
		if(!empty($this->int_periode)){
			$this->obj_tmpl->addVar('display', 'view', 'data');
		}
	}
	
	private function DisplayHasilEvaluasi(){
		$result = $this->obj_cpd->GetDataAsSingleArray("GetDetailPeriodeStrById", array($this->str_userid, $this->int_periode));
		if(!empty($result)){
			if($result['status_evaluasi'] == 'accepted'){
				$this->obj_tmpl->addVar('kelayakan', 'kegiatan', 'layak');
			}elseif($result['status_evaluasi'] == 'rejected'){
				$this->obj_tmpl->addVar('kelayakan', 'kegiatan', 'belum');
				self::DisplayKegiatanDianjurkan();
				self::DisplayTopikDianjurkan();
			}
		}else{
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], 'hasil', 'evaluasi');
		}
	}
	
	private function DisplayKegiatanDianjurkan(){
		$rs_id = $this->obj_cpd->GetResourceId("GetKegiatanDianjurkanByPeriode", array($this->str_userid, $this->int_periode));
		if($rs_id){
			$no = 1;
			while($rec = mysql_fetch_assoc($rs_id)){
				$this->obj_tmpl->addVar('list_kegiatan', 'NO', $no);
				$this->obj_tmpl->addVar('list_kegiatan', 'NAMA_KEGIATAN', $rec['nama']);
				$this->obj_tmpl->parseTemplate('list_kegiatan', 'a');
				$no++;
			}
		}else{
			$this->obj_tmpl->setAttribute('list_kegiatan', 'visibility', 'hidden');
		}
	}
	
	private function DisplayTopikDianjurkan(){
		$rs_id = $this->obj_cpd->GetResourceId("GetTopikDianjurkanByPeriode", array($this->str_userid, $this->int_periode));
		if($rs_id){
			$no = 1;
			while($rec = mysql_fetch_assoc($rs_id)){
				$this->obj_tmpl->addVar('list_topik', 'NO', $no);
				$this->obj_tmpl->addVar('list_topik', 'NAMA_TOPIK', $rec['topik']);
				$this->obj_tmpl->parseTemplate('list_topik', 'a');
				$no++;
			}
		}else{
			$this->obj_tmpl->setAttribute('list_topik', 'visibility', 'hidden');
		}
	}
	
	private function DisplayDetailPerson(){
		$result = $this->obj_cpd->GetDataAsSingleArray("GetDetailAnggotaByIdPerson", array($this->str_userid));
		if(!empty($result)){			
			$this->obj_tmpl->addVar('display', 'PREFIX', $result['prefix']);
			$this->obj_tmpl->addVar('display', 'SUFFIX', $result['suffix']);
			$this->obj_tmpl->addVar('display', 'NAMA', $result['nama_lengkap']);
			$this->obj_tmpl->addVar('display', 'NO_ANGGOTA', $result['no_anggota']);
		}
	}
}

?>