<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// object definition
	protected $obj_cpd;
	// protected $obj_notify;
	// variable definition
	protected $arr_params;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		
	}		
	
	protected function ParseDocumentOutput(){
		/** Redirect result to default page */
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'evaluasi');	
	}
	
	protected function PageLoad(){ 
		/* -- Other object loaded below */
		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);
		$loaded_query = array('evaluasi');
		$this->obj_cpd->SetUsesQuery($loaded_query);
		// --
		// $this->obj_notify = $this->obj_ctrl->LoadLibrary('Notification');
	}
	
	public function PageView(){
		// important to encypte bug post form
		if(isset($_POST['save'])){ 
			$action = array_keys($_POST['save']); 
			$this->arr_params = $_POST;
			unset($_POST);
		}else{
			$action = FALSE;
		}
		// controller to manage process that page requested
		switch($action[0]){
			case 'pengajuan':
				self::PengajuanEvaluasiPerTahun();
				break;
			case 'verifikasi':
				self::VerifikasiKegiatan();
				break;
			case 'evaluasi':
				self::EvaluasiPeriodeStr();
				break;
			default:
				break;
		}
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	// notification method
	private function SendNotification($err, $filled, $msg, $type){
		$this->obj_notify->ClearSession();
		$this->obj_notify->SetHeaderMessage($type, $msg);
		// error send
		foreach($err as $val){
			$this->obj_notify->SetMessage($val);
		}		
		// field value history
		for($i=0;$i<count($filled);$i++){
			$name = array_keys($filled);
			$this->obj_notify->SetField($name[$i], $filled[$name[$i]]);
		}
		$this->obj_notify->SentMessage();
	}
		
	// operation
	private function PengajuanEvaluasiPerTahun(){
		// check / validate parameter 
		$err = array();	
		$filled = array();	
		// required
		if(empty($this->arr_params['id_periode'])){ $err[] = '<br /><strong>Periode </strong>not selected'; }
		$this->obj_cpd->ProcessingData("HapusPengajuanEvaluasiPerTahun", array($this->arr_params['id_periode']));
		// processing --------------------------------------------------
		if(empty($err)){
			if(isset($this->arr_params['downcheck'])){
				foreach($this->arr_params['downcheck'] as $id){
					if($this->obj_cpd->ProcessingData("PengajuanEvaluasiPerTahun", array($id))){
						// notification message			
						// self::SendNotification($err, $filled, 'Data telah diajukan.', 'success');
						// redirect to success page ------------------------------------
					}
				}
				// save history
				$history['user'] = $this->str_userid;
				$history['target'] = "member";
				$history['title'] = "Pengajuan evaluasi kegiatan PKB";
				$history['deskripsi'] = "Permohonan kepada komisi PKB untuk melakukan evaluasi terhadap kegiatan PKB yang telah dicatatkan.";
				$history['url_title'] = "Hasil evaluasi kegiatan PKB";
				$history['url_link'] = HTTPPATH . "index.php/private/cpd/hasil-evaluasi/";
				$this->obj_cpd->AddActivitiesHistory($history);
			}			
		}else{
			// error message
			// self::SendNotification($err, $filled, 'Business process failure.', 'error');
			// redirect to page error page ------------------------------------		
		}
		$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'evaluasi', array($this->arr_params['id_periode']));
	}
	
}

?>