<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{		
	protected $obj_cpd;
	protected $obj_date;
	// variable definition
	protected $int_periode = '';
	protected $str_tgl_mulai;
	protected $str_tgl_selesai;
	protected $arr_ranah_all = array();
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		// set page templates
		$this->obj_tmpl->setBasedir(APPPATH.$this->arr_routes['app'].'/'.$this->arr_routes['group'].'/module/'.$this->arr_routes['module'].'/'.$this->arr_routes['page']);		
        $this->obj_tmpl->readTemplatesFromFile('template.html');
	}		
	
	protected function ParseDocumentOutput(){
		/** Out the result as template */
		$this->obj_tmpl->displayParsedTemplate('document');		
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		/* Other object loaded below */
		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);
		$loaded_query = array('evaluasi', 'kegiatan', 'str');
		$this->obj_cpd->SetUsesQuery($loaded_query);
		// --
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');	
	}
	
	public function PageView(){
		// display variable
		self::DisplayVariable();
		// display detail user
		self::DisplayDetailPerson();
		// display str
		self::DisplayDetailSTR();
		// display str
		self::DisplaySuratRekomendasi();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
	
	private function DisplayVariable(){
		// periode
		if(isset($this->arr_routes['params'][0])){
			$this->int_periode = $this->arr_routes['params'][0];
		}
		// top link
		$this->obj_tmpl->addVar('content', 'URL_VIEW', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], $this->arr_routes['page']));
		$this->obj_tmpl->addVar('result', 'URL_PROCESS', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'process'));
		// sub link
		$this->obj_tmpl->addVar('content', 'URL_REKAPITULASI', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'evaluasi', array($this->int_periode)));
		$this->obj_tmpl->addVar('content', 'URL_PENILAIAN', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'penilaian', array($this->int_periode)));
		$this->obj_tmpl->addVar('content', 'URL_PKB', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'p2kb', array($this->int_periode)));
		$this->obj_tmpl->addVar('content', 'URL_SURAT', $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'rekomendasi', array($this->int_periode)));
	}
	
	private function DisplayDetailPerson(){
		$result = $this->obj_cpd->GetDataAsSingleArray("GetDetailAnggotaByIdPerson", array($this->str_userid));
		if(!empty($result)){	
			$this->obj_tmpl->addVar('display', 'PREFIX', $result['prefix']);
			$this->obj_tmpl->addVar('display', 'SUFFIX', $result['suffix']);
			$this->obj_tmpl->addVar('display', 'NAMA', $result['nama_lengkap']);
			$this->obj_tmpl->addVar('display', 'NO_ANGGOTA', $result['no_anggota']);
		}
	}
	
	private function DisplayDetailSTR(){
		$result = $this->obj_cpd->GetDataAsSingleArray("GetDetailPeriodeStrById", array($this->str_userid, $this->int_periode));
		if(!empty($result)){
			$tgl_periode = $this->obj_date->GetFullDate($result['tgl_mulai']) . ' s/d ' .$this->obj_date->GetFullDate($result['tgl_selesai']);
			$this->obj_tmpl->AddVar('content', 'STR_PERIODE', $tgl_periode);
		}else{
			$this->obj_ctrl->RedirectPage($this->arr_routes['app'], $this->arr_routes['group'], 'hasil', 'evaluasi');
		}
	}
	
	private function DisplaySuratRekomendasi(){
		$result=$this->obj_cpd->GetDataAsSingleArray("GetSuratRekomendasiByStr", array($this->str_userid, $this->int_periode));
		if(!empty($result)){
			$this->obj_tmpl->AddVar('display', 'view', 'data');
			$url_download = $this->obj_ctrl->GetUrl($this->arr_routes['app'], $this->arr_routes['group'], $this->arr_routes['module'], 'download-rekomendasi', array($this->str_userid, $this->int_periode));
			// download
			if($result['downloaded'] == 'yes'){
				$this->obj_tmpl->addVar('download', 'view', 'downloaded');
				$this->obj_tmpl->addVar('download', 'URL_DOWNLOAD', $url_download);
			}else{
				$this->obj_tmpl->addVar('download', 'URL_DOWNLOAD', '#');
			}
		}
	}
}

?>