<?php
if (!defined('BASEPATH')) exit('No direct script access allowed');

class ApplicationContent extends ApplicationBase
{	
	// object definition
	protected $obj_cpd;
	// variable definition
	protected $arr_params;
	
	function __construct(){ }
	
	function __destruct(){ }
	
	protected function SetPageTemplates(){
		
	}		
	
	protected function ParseDocumentOutput(){
		/** Redirect result to default page */
		// pdf	
	}
	
	protected function PageLoad(){ 
		// themes setting
		// --
		// call function to set page templates
		$this->SetPageTemplates();
		/* Other object loaded below */
		$this->obj_cpd = $this->obj_ctrl->LoadBusiness('cpd_user', 'mysql', $this->arr_config['db']);
		$loaded_query = array('kompetensi');
		$this->obj_cpd->SetUsesQuery($loaded_query);
		// -- 
		$this->obj_date = $this->obj_ctrl->LoadLibrary('DateTimeManipulation');
		// load plugins
		$this->obj_ctrl->LoadFile('tcpdf/tcpdf.php', 'plugins');
		$this->obj_tcpdf = $this->obj_ctrl->LoadClass('TCPDF');
	}
	
	public function PageView(){
		// display pdf download
		self::DownloadSuratRekomendasi();
	}
	
	/* 
	| ------------------------------------------------------------------
	| private function to parse output from business class
	| ------------------------------------------------------------------
	*/
		
	// operation
	private function DownloadSuratRekomendasi(){
		$person = $this->obj_cpd->GetDataAsSingleArray("GetDetailAnggotaByIdPerson", array($this->arr_routes['params'][0]));
		$path = "doc/temp/blank.jpg";
		if(!empty($person)){
			// display foto
			$path = "doc/person/".$person['id_person']."/foto/".$person['photo'];
			if(!is_file($path))
				$path = "doc/temp/blank.jpg";
		}
		// parse data
		$result = $this->obj_cpd->GetDataAsSingleArray("GetSuratKompetensiByStr", array($this->arr_routes['params'][0], $this->arr_routes['params'][1]));
		// print pdf
		$this->obj_tcpdf->setPrintHeader(false);
		$this->obj_tcpdf->setPrintFooter(false);
		$this->obj_tcpdf->SetDisplayMode('real');
		$this->obj_tcpdf->SetMargins(10, 10);		
		// add a page
		$this->obj_tcpdf->AddPage();	
		$this->obj_tcpdf->SetFont("arial", "BI", 10);	
		// create some HTML content
		$tablealign = '
<table border="none" width="100%" cellpadding="2">
  <tr>
    <td width="70" align="left"><img src="doc/temp/p2kb-logo.png" width="50" height="50" /></td>
    <td align="center" width="400"><b>KOMISI PENGEMBANGAN PENDIDIKAN KEPROFESIAN BERKELANJUTAN (PKB)<br />
     Persatuan Perawat Nasional Indonesia(Persatuan Perawat Nasional Indonesia)</b><br />
      <br />
      <font size="9">Sekretariat : RSCM, Lt.II G3, Jalan Diponegoro 71, Jakarta 10430,<br />
      Telp/Fax: 021-3909431, E-mail: p2kb_ppni@yahoo.com</font></td>
    <td width="70" align="right"><img src="doc/temp/logo-ppni.jpg" width="50" height="50" /></td>
  </tr>
</table>
<br />
<img src="doc/temp/hr.jpg" width="530" />
<br />
<br />
<table border="none" width="100%">
  <tr>
    <td colspan="3" align="center"><b>SURAT REKOMENDASI KEPADA KOLEGIUM Persatuan Perawat Nasional Indonesia</b></td>
  </tr>
  <tr>
    <td colspan="3"></td>
  </tr>
  <tr>
    <td colspan="3"></td>
  </tr>
  <tr>
    <td width="170">No</td>
    <td width="15">:</td>
    <td>'.$result['nomor_surat'].'</td>
  </tr>
  <tr>
    <td width="170">Hal</td>
    <td width="15">:</td>
    <td>'.$result['perihal'].'</td>
  </tr>
  <tr>
	<td width="170">Lampiran</td>
    <td width="15">:</td>
    <td>'.$result['lampiran'].'</td>
  </tr>
  <tr>
    <td colspan="3"></td>
  </tr>
  <tr>
    <td colspan="3"></td>
  </tr>
  <tr>
    <td colspan="3" align="left"> Kepada Yth,<br />
      Ketua Kolegium <br />
      Di<br />
      Jakarta</td>
  </tr>
  <tr>
    <td colspan="3"></td>
  </tr>
  <tr>
    <td colspan="3"></td>
  </tr>
  <tr>
    <td colspan="3">Yang bertanda tangan dibawah ini menerangkan bahwa :</td>
  </tr>
  <tr>
    <td colspan="3"></td>
  </tr>
  <tr>
    <td width="170">Nama</td>
    <td width="15">:</td>
    <td width="300">'.$person['prefix'].' '.$person['nama_lengkap'].' '.$person['suffix'].'</td>
  </tr>
  <tr>
    <td colspan="3"></td>
  </tr>
  <tr>
    <td width="170">Nomor anggota IDI</td>
    <td width="15">:</td>
    <td>'.$person['no_idi'].'</td>
  </tr>
  <tr>
    <td colspan="3"></td>
  </tr>
  <tr>
    <td width="170">Nomor anggota Persatuan Perawat Nasional Indonesia</td>
    <td width="15">:</td>
    <td>'.$person['no_anggota'].'</td>
  </tr>
  <tr>
    <td colspan="3"></td>
  </tr>
  <tr>
    <td width="170">Alamat</td>
    <td width="15">:</td>
    <td width="300">'.$person['alamat'].'</td>
  </tr>
  <tr>
    <td colspan="3"></td>
  </tr>
  <tr>
    <td colspan="3">Berdasarkan penilaian atas dokumen PKB, yang bersangkutan dinyatakan memenuhi syarat sehingga layak mendapat rekomendasi untuk memperoleh sertifikat kompetensi.</td>
  </tr>
  <tr>
    <td colspan="3"></td>
  </tr>
  <tr>
    <td colspan="3">'.$result['tmp_terbit'].', '.$this->obj_date->GetFullDate($result['tgl_terbit'], 'in').'</td>
  </tr>
  <tr>
    <td colspan="3">Ketua Komisi PKB Persatuan Perawat Nasional Indonesia</td>
  </tr>
  <tr>
    <td colspan="3" align="left"><img src="doc/temp/signature/tanda_tangan.jpg" /></td>
  </tr>
  <tr>
    <td colspan="3" align="left">'.$result['ketua'].'</td>
  </tr>
</table>
';
		// output the HTML content
		$this->obj_tcpdf->writeHTML($tablealign, true, 0, true, 0);
		//Close and output PDF document
		$this->obj_tcpdf->Output("Surat-Kompetensi-Kolegium.pdf", "D");
	}
	
}

?>